# gcc_atomics.m4
#
# The content of this macro is taken from configure.ac of librdmacm
# Copyright 2012-2014 Intel Corporation

# GCC_CHECK_ATOMICS([action-if-found], [action-if-not-found])
# -----------------------------------------------------------
# Define HAVE_GCC_SYNC_ATOMICS to 1 if the compiler supports
# gcc 4.4-style atomics.
AC_DEFUN([GCC_CHECK_ATOMICS],
[# Check for gcc atomic intrinsics
AC_MSG_CHECKING(compiler support for atomics)
AC_LINK_IFELSE([AC_LANG_PROGRAM([[int i = 0;]],
				[[ return __sync_add_and_fetch(&i, 1) != __sync_sub_and_fetch(&i, 1); ]])],
    [AC_MSG_RESULT([yes])
     AC_DEFINE([HAVE_GCC_SYNC_ATOMICS], 1, [Set to 1 if have gcc __sync atomics])
     m4_ifval([$1],[$1],)
    ],
    [AC_MSG_RESULT(no)
     m4_ifval([$2],[$2],)
    ])
])# GCC_CHECK_ATOMICS
